package trafficSim;

import java.util.List;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.grid.GridCell;
import repast.simphony.query.space.grid.GridCellNgh;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;

public class CarSpawner {
	
	private List<ExitStart> exitStarts;
	private Context<Object> context;
	private ContinuousSpace<Object> space;
	private Grid<Object> grid;
	
	//Spawners for partially actuated
	
	private static final double spawner1Int = 4; //Left 5
	private static final double spawner1Start = 9;
	private static final double spawner2Int = 4; //Right 5
	private static final double spawner2Start = 6;
	private static final double spawner3Int = 100; //Bottom 60
	private static final double spawner3Start = 4;
	private static final double spawner4Int = 100; //Top 60
	private static final double spawner4Start = 1;
	
	
	private static final double spawner1IntSPIKE = 3; //Left 5
	private static final double spawner1StartSPIKE = 1;
	private static final double spawner2IntSPIKE = 3; //Right 5
	private static final double spawner2StartSPIKE = 1;
	private static final double spawner3IntSPIKE = 30; //Bottom 60
	private static final double spawner3StartSPIKE = 1;
	private static final double spawner4IntSPIKE = 30; //Top 60
	private static final double spawner4StartSPIKE = 1;
	
	
	private int tick;
	
	
	//Spawners for fully actuated
	/*
	private static final double spawner1Int = 18; //Left
	private static final double spawner1Start = 5;
	private static final double spawner2Int = 22; //Right
	private static final double spawner2Start = 10;
	private static final double spawner3Int = 13; //Bottom
	private static final double spawner3Start = 15;
	private static final double spawner4Int = 10; //Top
	private static final double spawner4Start = 20;
	*/
	
	private int leftCars = 10;
	private int rightCars = 60;
	private int bottomCars = 10;
	private int topCars = 10;
	private double chance;
	
	public CarSpawner(Context<Object> context, ContinuousSpace<Object> space, Grid<Object> grid, List<ExitStart> exitStarts, double chance) {
		this.exitStarts = exitStarts;
		this.context = context;
		this.space = space;
		this.grid = grid;
		this.chance = chance;
		tick = 0;
	}
	/*
	@ScheduledMethod(start = 1, interval = 1)
	public void timer() {
		tick++;
	}
	
	
	@ScheduledMethod(start = spawner1Start, interval = spawner1Int)
	public void carSpawner1() {
		GridPoint coords = exitStarts.get(0).getStart();
		if(!isCar(coords)) {
			if(tick < 1000 || tick > 4000) continuousCarSpawn(coords);
		}
		
	}
	
	@ScheduledMethod(start = spawner2Start, interval = spawner2Int)
	public void carSpawner2() {
		GridPoint coords = exitStarts.get(1).getStart();
		if(!isCar(coords)) {
			if(tick < 1000 || tick > 4000) continuousCarSpawn(coords);
		}
	}
	
	@ScheduledMethod(start = spawner3Start, interval = spawner3Int)
	public void carSpawner3() {
		GridPoint coords = exitStarts.get(2).getStart();
		if(!isCar(coords)) {
			if(tick < 1000 || tick > 4000) continuousCarSpawn(coords);
		}
	}
	
	@ScheduledMethod(start = spawner4Start, interval = spawner4Int)
	public void carSpawner4() {
		GridPoint coords = exitStarts.get(3).getStart();
		if(!isCar(coords)) {
			if(tick < 1000 || tick > 4000) continuousCarSpawn(coords);
		}
	}
	
	//SPIKE
	@ScheduledMethod(start = spawner1StartSPIKE, interval = spawner1IntSPIKE)
	public void carSpawner1SPIKE() {
		GridPoint coords = exitStarts.get(0).getStart();
		if(!isCar(coords)) {
			if(tick > 1000 && tick < 4000) continuousCarSpawn(coords);
		}
		
	}
	
	@ScheduledMethod(start = spawner2StartSPIKE, interval = spawner2IntSPIKE)
	public void carSpawner2SPIKE() {
		GridPoint coords = exitStarts.get(1).getStart();
		if(!isCar(coords)) {
			if(tick > 1000 && tick < 4000) continuousCarSpawn(coords);
		}
	}
	
	@ScheduledMethod(start = spawner3StartSPIKE, interval = spawner3IntSPIKE)
	public void carSpawner3SPIKE() {
		GridPoint coords = exitStarts.get(2).getStart();
		if(!isCar(coords)) {
			if(tick > 1000 && tick < 4000) continuousCarSpawn(coords);
		}
	}
	
	@ScheduledMethod(start = spawner4StartSPIKE, interval = spawner4IntSPIKE)
	public void carSpawner4SPIKE() {
		GridPoint coords = exitStarts.get(3).getStart();
		if(!isCar(coords)) {
			if(tick > 1000 && tick < 4000) continuousCarSpawn(coords);
		}
	}
	*/

	//SPOUTN PRO SIMULACI 1
	@ScheduledMethod(start = spawner1Start, interval = spawner1Int)
	public void carSpawner1() {
		GridPoint coords = exitStarts.get(0).getStart();
		if(!isCar(coords)) {
			continuousCarSpawn(coords);
		}
		
	}
	
	@ScheduledMethod(start = spawner2Start, interval = spawner2Int)
	public void carSpawner2() {
		GridPoint coords = exitStarts.get(1).getStart();
		if(!isCar(coords)) {
			continuousCarSpawn(coords);
		}
	}
	
	@ScheduledMethod(start = spawner3Start, interval = spawner3Int)
	public void carSpawner3() {
		GridPoint coords = exitStarts.get(2).getStart();
		if(!isCar(coords)) {
			continuousCarSpawn(coords);
		}
	}
	
	@ScheduledMethod(start = spawner4Start, interval = spawner4Int)
	public void carSpawner4() {
		GridPoint coords = exitStarts.get(3).getStart();
		if(!isCar(coords)) {
			continuousCarSpawn(coords);
		}
	}
	
	public void singularCarSpawn(int amount1, int amount2, int amount3, int amount4) {
		for(int i = 0; i < amount1; i++) {
			GridPoint coords = exitStarts.get(0).getStart();
			Car car = new Car(space, grid, coords, chance);
			context.add(car);
			grid.moveTo(car, coords.getX(), coords.getY());
			space.moveTo(car, coords.getX(), coords.getY());
		}
		
		for(int i = 0; i < amount2; i++) {
			GridPoint coords = exitStarts.get(1).getStart();
			Car car = new Car(space, grid, coords, chance);
			context.add(car);
			grid.moveTo(car, coords.getX(), coords.getY());
			space.moveTo(car, coords.getX(), coords.getY());
		}
		
		for(int i = 0; i < amount3; i++) {
			GridPoint coords = exitStarts.get(2).getStart();
			Car car = new Car(space, grid, coords, chance);
			context.add(car);
			grid.moveTo(car, coords.getX(), coords.getY());
			space.moveTo(car, coords.getX(), coords.getY());
		}
		
		for(int i = 0; i < amount4; i++) {
			GridPoint coords = exitStarts.get(3).getStart();
			Car car = new Car(space, grid, coords, chance);
			context.add(car);
			grid.moveTo(car, coords.getX(), coords.getY());
			space.moveTo(car, coords.getX(), coords.getY());
		}
	}
	
	public void continuousCarSpawn(GridPoint coords) {
		if(!isCar(coords)) {
			Car car = new Car(space, grid, coords, chance);
			context.add(car);
			grid.moveTo(car, coords.getX(), coords.getY());
			space.moveTo(car, coords.getX(), coords.getY());
		}
	}
	
	private boolean isCar(GridPoint nextPos) {
		GridCellNgh<Car> nghCreator = new GridCellNgh<Car>(grid, nextPos, Car.class, 0, 0);
		List<GridCell<Car>> gridCells = nghCreator.getNeighborhood(true);
		for (GridCell<Car> gridCell : gridCells) {
			if(gridCell.size() > 0) {
				return true;
			}
		}
		return false;
	}

}
