package trafficSim;

import java.util.ArrayList;
import java.util.List;

import repast.simphony.context.Context;
import repast.simphony.space.continuous.ContinuousSpace;

import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;

public class Semafor {
	
	private Grid<Object> grid;
	private ContinuousSpace<Object> space;
	private Context<Object> context;
	private int x, y;
	
	public Semafor(int x, int y, Grid<Object> grid, ContinuousSpace<Object> space, Context<Object> context) {
		this.grid = grid;
		this.space = space;
		this.context = context;
		this.x = x;
		this.y = y;
		
		generateLights();
	}

	public void generateLights() {
		List<GridPoint> tlLoc = new ArrayList<GridPoint>();
		
		tlLoc.add(new GridPoint(x, y + 2));
		tlLoc.add(new GridPoint(x + 1, y - 1));
		tlLoc.add(new GridPoint(x - 1, y));
		tlLoc.add(new GridPoint(x + 2, y + 1));
		
		for(int i = 0; i <= 3; i++) {
			Red red = new Red();
			context.add(red);
			grid.moveTo(red, tlLoc.get(i).getX(), tlLoc.get(i).getY());
			space.moveTo(red, tlLoc.get(i).getX(), tlLoc.get(i).getY());
			context.add(red);
		}
	}
	
}
