package trafficSim;

import java.util.List;

import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.grid.GridCell;
import repast.simphony.query.space.grid.GridCellNgh;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.continuous.NdPoint;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridPoint;

public class Sensor {
	
	private Grid<Object> grid;
	private int amountOfCars;
	private GridPoint currentPos;
	private ContinuousSpace<Object> space;
	private Car car;
	
	
	public Sensor(Grid<Object> grid, ContinuousSpace<Object> space, GridPoint currentPos) {
		this.grid = grid;
		this.currentPos = currentPos;
		this.space = space;
		amountOfCars = 0;
	}
	
	@ScheduledMethod(start = 1, interval = 1, priority = 10)
	public void addCar() {
		if(isCar()) {
			amountOfCars++;
		}
	}
	
	private boolean isCar() {
		Iterable<Object> objects = grid.getObjectsAt(currentPos.getX(), currentPos.getY());
		for (Object object : objects) {
			if(object.getClass() == Car.class) {
				return true;
			}
		}
		return false;
	}
	
	private boolean isCarSpace() {
		Iterable<Object> objects = space.getObjectsAt(currentPos.getX(), currentPos.getY());
		for (Object object : objects) {
			if(object.getClass() == Car.class) {
				return true;
			}
		}
		return false;
	}
	
	private boolean isCar2() {
		GridCellNgh<Car> nghCreator = new GridCellNgh<Car>(grid, grid.getLocation(this), Car.class, 0, 0);
		List<GridCell<Car>> gridCells = nghCreator.getNeighborhood(true);
		for (GridCell<Car> gridCell : gridCells) {
			if(gridCell.size() > 0) {
				return true;
			}
		}
		return false;
	}

	public int getAmountOfCars() {
		return amountOfCars;
	}

	public void setAmountOfCars(int amountOfCars) {
		this.amountOfCars = amountOfCars;
	}
	
	public void addAmount() {
		amountOfCars++;
	}
}
