package trafficSim;

import java.awt.Color;
import java.io.IOException;

import repast.simphony.visualization.gui.styleBuilder.IconFactory2D;
import repast.simphony.visualizationOGL2D.DefaultStyleOGL2D;
import saf.v3d.scene.VSpatial;

public class TrafficStyle extends DefaultStyleOGL2D {
	
	@Override
	public Color getColor(Object obj) {
		if(obj.getClass() == TrafficLight.class) {
			TrafficLight tl = (TrafficLight) obj;
			switch (tl.getCurrentColor()) {
			case 1:
				return Color.green;
			case 2:
				return Color.orange;
			default:
				return Color.red;
			}
		}
		return null;
	}
	
	@Override
	public VSpatial getVSpatial(Object agent, VSpatial spatial) {
		if(agent.getClass() == TrafficLight.class) {
			TrafficLight tl = (TrafficLight) agent;
			spatial = shapeFactory.createCircle(5, 6, true);
			return spatial;
		}
		if(agent.getClass() == Car.class) {
			Car car = (Car) agent;	
			spatial.rotate2D((float)0.45);
				//spatial.rotate2D(angle);
				return spatial;
			
		}
		return null;
	}

}
